/*
Plugin dzieki ktoremu mozemy wlaczyc danej osobie lub teamowi opcje
dzieki ktorej jak wyjma noz robia sie niewidzialni

KOMENDA:
amx_ninja <nick or #userid or @team> [1=ON | 0=OFF | else]
else - warto inna ni 1/0 lub brak wartoci zmieni stan z ON na OFF lub przeciwnie

CVAR:
sv_ninja_allon 0 (czy wszyscy maja miec standardowo Ninja ON)
sv_ninja_alpha 0 (widoczno gracza z noem 0-255)
*/

#include <amxmodx>
#include <amxmisc>
#include <fakemeta>

#define PLUGIN "Ninja"
#define VERSION "1.1.1"
#define AUTHOR "Pavulon"

new plninja[33]
new Float:alpha = 0.0

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)

	register_event("CurWeapon", "event_curweapon", "be","1=1")

	register_concmd("amx_ninja","admin_ninja",ADMIN_KICK,"<nick or #userid or @team> [1=ON | 0=OFF | else]")

	register_logevent("Poczatek_Rundy", 2, "1=Round_Start")

	register_cvar("sv_ninja_alpha", "0")
	register_cvar("sv_ninja_allon", "0")
}
public Poczatek_Rundy()
{
	alpha = get_cvar_float("sv_ninja_alpha")
	new Float:SPTime = get_cvar_float("sv_sptime")
	set_task(SPTime+1.0, "check_ninja", 997)
}
public admin_ninja(id,level,cid)
{
	if (!cmd_access(id,level,cid,2)) return PLUGIN_HANDLED
	
	new nickorid[32]
	new onoff[2]
	new players[32]
	new ret[42]
	new ret2[10]
	read_argv(1,nickorid,31)
	read_argv(2,onoff,1)

	new opcja, num
	if (!equal(onoff,"")) opcja = str_to_num(onoff)
	else opcja = 2

	if ( nickorid[0] == '@' )
	{
		if ( nickorid[1] == 'a' || nickorid[1] == 'A' )
		{
			playnum(players,num,"a")
			format ( ret, 41, "Ninja @ ALL" )
		}
		else if ( nickorid[1] == 'c' || nickorid[1] == 'C' )
		{
			playnum(players,num,"ae","CT")
			format ( ret, 41, "Ninja @ CT" )
		}
		else if ( nickorid[1] == 't' || nickorid[1] == 'T' )
		{
			playnum(players,num,"ae","TERRORIST")
			format ( ret, 41, "Ninja @ T" )
		} else
			return PLUGIN_HANDLED
	} else
	{
		new player = cmd_target(id,nickorid,3)
		if (player==0)
		{
			client_print(id,print_chat,"Nie znalesiono gracza ^"%s^"",nickorid)
			return PLUGIN_HANDLED
		}
		new name[32]
		get_user_name (player, name, 31)
		players[0] = player
		num = 1
		format(ret, 41, "Ninja @ %s", name)
	}
	for (new i=0; i<num ; i++)
	{
		new who = players[i]
		switch(opcja)
		{
			case 0:
			{
				plninja[who] = 0
				set_pev(who, pev_renderamt, 255.0)
			}
			case 1:	
			{
				plninja[who] = 1
				new weapon = get_user_weapon(who) 
				if (weapon == CSW_KNIFE ) set_pev(who, pev_renderamt, alpha)
			}
			default:
			{
				if (plninja[who]==1)
				{
					plninja[who] = 0
					set_pev(who, pev_renderamt, 255.0)
				}
				else
				{
					plninja[who] = 1
					new weapon = get_user_weapon(who) 
					if (weapon == CSW_KNIFE ) set_pev(who, pev_renderamt, alpha)
				}
			}
		}
	}
	switch(opcja)
	{
		case 0: format(ret2, 9, "OFF")
		case 1: format(ret2, 9, "ON")
		default: format(ret2, 9, "ON/OFF")
	}
	client_print(id,print_chat,"%s %s",ret, ret2)
	return PLUGIN_HANDLED
	
}


public event_curweapon (id)
{
	if (plninja[id]==1 || get_cvar_num("sv_ninja_allon")==1)
	{
		new weapon = read_data(2) 

		if (weapon == CSW_KNIFE ) set_pev(id, pev_renderamt, alpha)	
		else set_pev(id, pev_renderamt, 255.0)
	}
}
public check_ninja()
{
	new players[32],num

	get_players(players,num)
	for (new i=0; i<num ; i++)
	{
		new id=players[i]
	
		if (plninja[id]==1 || get_cvar_num("sv_ninja_allon")==1)
		{
			new weapon = get_user_weapon(id) 
			
			if (weapon == CSW_KNIFE )	set_pev(id, pev_renderamt, alpha)
			else set_pev(id, pev_renderamt, 255.0)
		}
	}
}
public client_connect(id)
{
	plninja[id]=0
}
public client_disconnect(id)
{
	plninja[id]=0
}

playnum(players[32], &num, const flags[]="", const team[]="")
{
	num = 0
	new pteam = 0
	if (equal(team,"CT"))	pteam = 2
	else if (equal(team,"TERRORIST")) pteam = 1
		
	if (read_flags(flags) & read_flags("a"))
	{
		new players2[32],num2
		get_players(players2,num2)
		if (read_flags(flags) & read_flags("e"))
			for (new i=0; i<num2 ; i++)
			{
				new id=players2[i]

				if (get_user_team(id)==pteam)
				{
					players[num] = id
					num++
				}
			}
		else 
		{
			for (new i=0; i<num2 ; i++)
				players[i] = players2[i]
			num = num2
		}
	}
}
